/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, callStaticConstructors, String_$type, markType } from "./type";
import { StockPricePoint } from "./StockPricePoint";
import { Dictionary$2 } from "./Dictionary$2";
import { Random } from "./Random";
import { dateNow } from "./date";
/**
 * @hidden
 */
export class StockDataLookup extends Base {
    static d(a, b, c, d, e) {
        if (StockDataLookup.b.containsKey(a)) {
        }
        else {
            let f = new StockPricePoint();
            f.symbol = a;
            f.company = b;
            f.open = c;
            f.close = c;
            f.volume = d;
            f.sector = e;
            StockDataLookup.b.addItem(a, f);
        }
    }
    static get(a) {
        if (StockDataLookup.b.containsKey(a)) {
            return StockDataLookup.b.item(a);
        }
        else {
            let b = new StockPricePoint();
            b.symbol = a;
            b.open = StockDataLookup.c.next2(100, 500);
            b.volume = StockDataLookup.c.next2(100000, 500000);
            StockDataLookup.b.addItem(a, b);
            return b;
        }
    }
    static staticInit() {
        let a = dateNow();
        StockDataLookup.b = new Dictionary$2(String_$type, StockPricePoint.$, 0);
        StockDataLookup.d("TSLA", "Tesla Inc", 332.01, 10834796, "Transportation");
        StockDataLookup.d("UBER", "Uber Technologies Inc", 38.79, 79442420, "Transportation");
        StockDataLookup.d("NVDA", "Nvidia Corp", 163.5, 16422819, "Technology");
        StockDataLookup.d("GOOG", "Alphabet Inc", 1204.11, 43944923, "Technology");
        StockDataLookup.d("QCOM", "Qualcomm Inc", 83.24, 16689039, "Technology");
        StockDataLookup.d("ROKU", "Roku Inc", 80.76, 22878291, "Technology");
        StockDataLookup.d("CSCO", "Cisco Systems Inc", 51.83, 28869931, "Technology");
        StockDataLookup.d("INTC", "Intel Corp", 45.33, 39091928, "Technology");
        StockDataLookup.d("ADBE", "Adobe Systems Inc", 270.565, 2698322, "Technology");
        StockDataLookup.d("AVGO", "Broadcom Inc", 293.82, 3786434, "Technology");
        StockDataLookup.d("LYFT", "Lyft Inc", 50, 10007408, "Transportation");
        StockDataLookup.d("PYPL", "PayPal Holdings Inc", 107.6, 5657900, "Financial");
        StockDataLookup.d("ORCL", "Oracle Corp", 53.72, 10664674, "Technology");
        StockDataLookup.d("SBUX", "Starbucks Corp", 77.25, 9778829, "Consumer Goods");
        StockDataLookup.d("TWTR", "Twitter Inc", 37.5, 16829698, "Communication");
        StockDataLookup.d("AMAT", "Applied Materials Inc", 39.26, 10725058, "Materials");
        StockDataLookup.d("ATVI", "Activision Blizzard Inc", 44.73, 9803138, "Technology");
        StockDataLookup.d("SNAP", "Snap Inc", 10.05, 15911862, "Communication");
        StockDataLookup.d("TMUS", "T-Mobile US Inc", 74.38, 3477107, "Communication");
        StockDataLookup.d("AMZN", "Amazon.com Inc", 1836.56, 5783410, "Technology");
        StockDataLookup.d("AAPL", "Apple Inc", 223.55, 957369, "Technology");
        StockDataLookup.d("MSFT", "Microsoft Corp", 124.11, 33944923, "Technology");
        StockDataLookup.d("NFLX", "Netflix Inc", 361.95, 16833347, "Communication");
        StockDataLookup.d("BABA", "Alibaba Group Holding Ltd", 169.79, 22330737, "Technology");
        StockDataLookup.d("BAC", "Bank of America Corp", 28.53, 5783410, "Financial");
        StockDataLookup.d("AMJ", "JP Morgan Chase & Co", 25.34, 1350492, "Financial");
        StockDataLookup.d("TXN", "Texas Instruments Inc", 109.17, 7867589, "Technology");
        StockDataLookup.d("CAT", "Caterpillar Inc", 127.51, 8580682, "Industrial");
        StockDataLookup.d("MMM", "3M Co", 173.935, 5916911, "Materials");
        StockDataLookup.d("DIS", "Walt Disney Co", 131.5, 11389896, "Communication");
        StockDataLookup.d("AMD", "Advanced Micro Devices Inc", 26.98, 99017893, "Technology");
        StockDataLookup.d("HON", "Honeywell Intl. Inc", 168.48, 3705165, "Materials");
        StockDataLookup.d("IBM", "Intl. Business Machines", 133.28, 4958021, "Technology");
        StockDataLookup.d("UTX", "United Technologies Corp", 134.03, 4119212, "Technology");
        StockDataLookup.d("CVS", "CVS Health Corp", 54.3, 11183821, "Consumer Goods");
        StockDataLookup.d("DAL", "Delta Air Lines Inc", 55.44, 5223811, "Transportation");
        StockDataLookup.d("CCZ", "Comcast Corp", 55.5, 410, "Communication");
        StockDataLookup.d("BBY", "Best Buy Co Inc", 70.3, 5408468, "Consumer Goods");
        StockDataLookup.d("AAL", "American Airlines Group Inc", 33.16, 7040853, "Transportation");
        StockDataLookup.d("CRM", "Salesforce.Com Inc", 154.92, 5694582, "Financial");
        StockDataLookup.d("C", "Citigroup Inc", 66.13, 23494395, "Financial");
        StockDataLookup.d("F", "Ford Motor Co", 10.17, 51102054, "Transportation");
        StockDataLookup.d("T", "AT&T Inc", 30.35, 27713285, "Communication");
        StockDataLookup.d("V", "Visa Inc", 157.19, 9729964, "Financial");
        StockDataLookup.d("GE", "General Electric Co", 9.85, 60136022, "Energy");
        StockDataLookup.d("MU", "Micron Technology Inc", 37.36, 33092081, "Technology");
        StockDataLookup.d("MA", "Mastercard Inc", 241.51, 4137245, "Financial");
        StockDataLookup.d("HD", "Home Depot Inc", 191, 3326028, "Materials");
        StockDataLookup.d("VZ", "Verizon Comm Inc", 56.72, 13759350, "Communication");
        StockDataLookup.d("EA", "Electronic Arts Inc", 92.01, 3685460, "Communication");
        StockDataLookup.d("FB", "Facebook Inc", 183.5, 16833347, "Technology");
        StockDataLookup.d("GM", "General Motors Company", 36.85, 19454839, "Transportation");
    }
}
StockDataLookup.$t = markType(StockDataLookup, 'StockDataLookup');
StockDataLookup.b = null;
StockDataLookup.c = new Random(0);
callStaticConstructors();
